commit be58a50cb9bea20a26f78b5b684aaa68de9d4586
Author: Assos Assos <assos+forge@centrale-marseille.fr>
Date:   Thu Mar 23 00:06:04 2017 +0100

    Weekly update of contrib modules

diff --git a/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.inc b/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.inc
index fa835ecb..c0586ac2 100644
--- a/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.inc
+++ b/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.inc
@@ -659,6 +659,14 @@ function ldap_authentication_test_credentials($auth_conf, $sso_login, $authname,
         */
       $credentials_pass = (boolean)($ldap_user);
     }
+    elseif ($ldap_server->bind_method == LDAP_SERVERS_BIND_METHOD_USER) {
+       /**
+        * With user bind method, the only way we can reach this part of the
+        * code is when the pw has already been checked and $ldap_user could be
+        * loaded, so we're good to go.
+        */
+      $credentials_pass = true;
+    }
     else {
       $credentials_pass = ($ldap_server->bind($ldap_user['dn'], $password, FALSE) == LDAP_SUCCESS);
     }
diff --git a/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.info b/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.info
index 610261fc..cbead42c 100644
--- a/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.info
+++ b/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.info
@@ -14,9 +14,9 @@ files[] = ldap_authentication.theme.inc
 files[] = ldap_authentication.admin.inc
 files[] = tests/ldap_authentication.test
 
-; Information added by Drupal.org packaging script on 2017-02-15
-version = "7.x-2.0-beta12"
+; Information added by Drupal.org packaging script on 2017-03-18
+version = "7.x-2.0"
 core = "7.x"
 project = "ldap"
-datestamp = "1487199794"
+datestamp = "1489858388"
 
diff --git a/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.module b/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.module
index d60aa39e..3b1409cc 100644
--- a/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.module
+++ b/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.module
@@ -212,7 +212,7 @@ function _ldap_authentication_verify_user_profile() {
       );
     }
   }
-  return TRUE;
+  return $result;
 }
 
 /**
@@ -335,7 +335,7 @@ function ldap_authentication_show_reset_pwd($user = NULL) {
   $auth_conf = ldap_authentication_get_valid_conf();
   // Hide user/password form if ldap authentication is required and deny access
   // to users without ldap authorizations is enabled
-  if ($user->uid == 1 || $auth_conf || (current_path() == 'user/password' && $auth_conf->authenticationMode != LDAP_AUTHENTICATION_EXCLUSIVE)) {
+  if ($user->uid == 1 || !$auth_conf || (current_path() == 'user/password' && $auth_conf->authenticationMode != LDAP_AUTHENTICATION_EXCLUSIVE)) {
     return TRUE;
    // always show at user/passwordurl. otherwise user 1 will not be able to reset password.
   }
diff --git a/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization.info b/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization.info
index a987d7f2..bdaf0ff7 100644
--- a/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization.info
+++ b/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization.info
@@ -17,9 +17,9 @@ files[] = tests/BasicTests.test
 files[] = tests/Og2Tests.test
 configure = admin/config/people/ldap/authorization
 
-; Information added by Drupal.org packaging script on 2017-02-15
-version = "7.x-2.0-beta12"
+; Information added by Drupal.org packaging script on 2017-03-18
+version = "7.x-2.0"
 core = "7.x"
 project = "ldap"
-datestamp = "1487199794"
+datestamp = "1489858388"
 
diff --git a/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization_drupal_role/ldap_authorization_drupal_role.info b/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization_drupal_role/ldap_authorization_drupal_role.info
index f49df6c6..52727904 100644
--- a/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization_drupal_role/ldap_authorization_drupal_role.info
+++ b/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization_drupal_role/ldap_authorization_drupal_role.info
@@ -9,9 +9,9 @@ files[] = LdapAuthorizationConsumerRole.class.php
 files[] = ldap_authorization_drupal_role.module
 files[] = ldap_authorization_drupal_role.inc
 
-; Information added by Drupal.org packaging script on 2017-02-15
-version = "7.x-2.0-beta12"
+; Information added by Drupal.org packaging script on 2017-03-18
+version = "7.x-2.0"
 core = "7.x"
 project = "ldap"
-datestamp = "1487199794"
+datestamp = "1489858388"
 
diff --git a/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization_og/ldap_authorization_og.info b/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization_og/ldap_authorization_og.info
index 394d1ab6..5e87dd8a 100644
--- a/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization_og/ldap_authorization_og.info
+++ b/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization_og/ldap_authorization_og.info
@@ -13,9 +13,9 @@ files[] = ldap_authorization_og.inc
 
 core = "7.x"
 
-; Information added by Drupal.org packaging script on 2017-02-15
-version = "7.x-2.0-beta12"
+; Information added by Drupal.org packaging script on 2017-03-18
+version = "7.x-2.0"
 core = "7.x"
 project = "ldap"
-datestamp = "1487199794"
+datestamp = "1489858388"
 
diff --git a/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization_og/ldap_authorization_og.module b/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization_og/ldap_authorization_og.module
index 45b742a3..682f201b 100644
--- a/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization_og/ldap_authorization_og.module
+++ b/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization_og/ldap_authorization_og.module
@@ -141,9 +141,9 @@ function ldap_authorization_og1_get_group($value, $value_type = 'group_name', $r
 /**
  * Generic function to convert between query values and organic groups structures and attributes
  *
- * @param mixed $value signifies query value e.g. 'bakers', 7 etc.
- * @param mixed $value_type signifies query type e.g. 'group_name', 'gid', etc.
- * @param string $return signifying return type. e.g.  'object', 'label', 'name', 'gid'
+ * @param mixed $entity_type signifies query value e.g. 'bakers', 7 etc.
+ * @param mixed $group_name signifies query type e.g. 'group_name', 'gid', etc.
+ *
  * @return mixed organic group object, gid, label, etc.
  */
 function ldap_authorization_og2_get_group_from_name($entity_type, $group_name) {
diff --git a/drupal7/sites/all/modules/ldap/ldap_feeds/ldap_feeds.info b/drupal7/sites/all/modules/ldap/ldap_feeds/ldap_feeds.info
index 0407c9da..e8bc244f 100644
--- a/drupal7/sites/all/modules/ldap/ldap_feeds/ldap_feeds.info
+++ b/drupal7/sites/all/modules/ldap/ldap_feeds/ldap_feeds.info
@@ -12,9 +12,9 @@ configure = admin/structure/feeds
 core = 7.x
 php = 5.2
 
-; Information added by Drupal.org packaging script on 2017-02-15
-version = "7.x-2.0-beta12"
+; Information added by Drupal.org packaging script on 2017-03-18
+version = "7.x-2.0"
 core = "7.x"
 project = "ldap"
-datestamp = "1487199794"
+datestamp = "1489858388"
 
diff --git a/drupal7/sites/all/modules/ldap/ldap_help/ldap_help.info b/drupal7/sites/all/modules/ldap/ldap_help/ldap_help.info
index 2866e076..fd82e0d3 100644
--- a/drupal7/sites/all/modules/ldap/ldap_help/ldap_help.info
+++ b/drupal7/sites/all/modules/ldap/ldap_help/ldap_help.info
@@ -5,9 +5,9 @@ core = 7.x
 
 dependencies[] = ldap_servers
 dependencies[] = ldap_test
-; Information added by Drupal.org packaging script on 2017-02-15
-version = "7.x-2.0-beta12"
+; Information added by Drupal.org packaging script on 2017-03-18
+version = "7.x-2.0"
 core = "7.x"
 project = "ldap"
-datestamp = "1487199794"
+datestamp = "1489858388"
 
diff --git a/drupal7/sites/all/modules/ldap/ldap_query/ldap_query.admin.inc b/drupal7/sites/all/modules/ldap/ldap_query/ldap_query.admin.inc
index 6f7f227c..5503af84 100644
--- a/drupal7/sites/all/modules/ldap/ldap_query/ldap_query.admin.inc
+++ b/drupal7/sites/all/modules/ldap/ldap_query/ldap_query.admin.inc
@@ -105,8 +105,8 @@ function ldap_query_admin_form_submit($form, &$form_state) {
    // }
   }
   else {
-    form_set_error($server->errorName(), $server->errorMsg());
-    $server->clearError();
+    form_set_error($query->errorName(), $query->errorMsg());
+    $query->clearError();
   }
   ldap_query_cache_clear();
 }
diff --git a/drupal7/sites/all/modules/ldap/ldap_query/ldap_query.info b/drupal7/sites/all/modules/ldap/ldap_query/ldap_query.info
index 8c3a3f68..549a33d6 100644
--- a/drupal7/sites/all/modules/ldap/ldap_query/ldap_query.info
+++ b/drupal7/sites/all/modules/ldap/ldap_query/ldap_query.info
@@ -17,9 +17,9 @@ files[] = tests/ldap_query.test
 
 configure = admin/config/people/ldap/query
 
-; Information added by Drupal.org packaging script on 2017-02-15
-version = "7.x-2.0-beta12"
+; Information added by Drupal.org packaging script on 2017-03-18
+version = "7.x-2.0"
 core = "7.x"
 project = "ldap"
-datestamp = "1487199794"
+datestamp = "1489858388"
 
diff --git a/drupal7/sites/all/modules/ldap/ldap_servers/LdapServer.class.php b/drupal7/sites/all/modules/ldap/ldap_servers/LdapServer.class.php
index a07205bf..97d9abcd 100644
--- a/drupal7/sites/all/modules/ldap/ldap_servers/LdapServer.class.php
+++ b/drupal7/sites/all/modules/ldap/ldap_servers/LdapServer.class.php
@@ -327,7 +327,7 @@ class LdapServer {
       return LDAP_CONNECT_ERROR;
     }
 
-    if ($anon_bind !== FALSE && $userdn === NULL && $pass === NULL && $this->bind_method == LDAP_SERVERS_BIND_METHOD_ANON) {
+    if ($anon_bind === FALSE && $userdn === NULL && $pass === NULL && $this->bind_method == LDAP_SERVERS_BIND_METHOD_ANON) {
       $anon_bind = TRUE;
     }
     if ($anon_bind === TRUE) {
@@ -463,11 +463,15 @@ class LdapServer {
       return FALSE;
     }
 
+    if (!empty($attributes['unicodePwd']) && ($this->ldap_type == 'ad')) {
+      $attributes['unicodePwd'] = ldap_servers_convert_password_for_active_directory_unicodePwd($attributes['unicodePwd']);
+    }
+
     $result = @ldap_add($this->connection, $dn, $attributes);
     if (!$result) {
       $error = "LDAP Server ldap_add(%dn) Error Server ID = %sid, LDAP Err No: %ldap_errno LDAP Err Message: %ldap_err2str ";
       $tokens = array('%dn' => $dn, '%sid' => $this->sid, '%ldap_errno' => ldap_errno($this->connection), '%ldap_err2str' => ldap_err2str(ldap_errno($this->connection)));
-      debug(t($error, $tokens));
+      //debug(t($error, $tokens));
       watchdog('ldap_server', $error, $tokens, WATCHDOG_ERROR);
     }
 
@@ -549,6 +553,11 @@ class LdapServer {
         $old_attributes =  $entries[0];
       }
     }
+
+    if (!empty($attributes['unicodePwd']) && ($this->ldap_type == 'ad')) {
+      $attributes['unicodePwd'] = ldap_servers_convert_password_for_active_directory_unicodePwd($attributes['unicodePwd']);
+    }
+
     $attributes = $this->removeUnchangedAttributes($attributes, $old_attributes);
 
     foreach ($attributes as $key => $cur_val) {
@@ -1139,7 +1148,12 @@ class LdapServer {
         && isset($ldap_entry[$this->unique_persistent_attr][0])
         && is_scalar($ldap_entry[$this->unique_persistent_attr][0])
         ) {
-      $puid = $ldap_entry[$this->unique_persistent_attr][0];
+      if (is_array($ldap_entry[$this->unique_persistent_attr])) {
+        $puid = $ldap_entry[$this->unique_persistent_attr][0];
+      }
+      else {
+        $puid = $ldap_entry[$this->unique_persistent_attr];
+      }
       return ($this->unique_persistent_attr_binary) ? ldap_servers_binary($puid) : $puid;
     }
     else {
diff --git a/drupal7/sites/all/modules/ldap/ldap_servers/LdapServerAdmin.class.php b/drupal7/sites/all/modules/ldap/ldap_servers/LdapServerAdmin.class.php
index be8c2e75..3490f8f0 100644
--- a/drupal7/sites/all/modules/ldap/ldap_servers/LdapServerAdmin.class.php
+++ b/drupal7/sites/all/modules/ldap/ldap_servers/LdapServerAdmin.class.php
@@ -691,6 +691,7 @@ public function drupalFormSubmit($op, $values) {
           'size' => 'small',
           'not null' => FALSE,
           'default' => 0,
+          'boolean' => FALSE,
         ),
       ),
 
@@ -877,8 +878,12 @@ public function drupalFormSubmit($op, $values) {
         'form' => array(
           'fieldset' => 'users',
           '#type' => 'checkbox',
-          '#title' => t('Does PUID hold a binary value?'),
-          '#description' => t(''),
+          '#title' => t('Does the <em>Persistent and Unique User ID
+            Attribute</em> hold a binary value?'),
+          '#description' => t('You need to set this if you are using a binary
+             attribute such as objectSid in ActiveDirectory for the PUID.<br>
+             If you don\'t want this consider switching to another attribute,
+             such as samaccountname.'),
         ),
         'schema' => array(
           'type' => 'int',
diff --git a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.drush.inc b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.drush.inc
new file mode 100644
index 00000000..1527af0f
--- /dev/null
+++ b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.drush.inc
@@ -0,0 +1,65 @@
+<?php
+
+/**
+ * @file
+ *   LDAP module drush integration.
+ */
+
+/**
+ * Implements hook_drush_command().
+ *
+ * @return
+ *   An associative array describing your command(s).
+ *
+ * @see drush_parse_command()
+ */
+function ldap_servers_drush_command() {
+  $items['ldap-servers-set-password'] = array(
+    'description' => 'Set the password of an otherwise already configured LDAP server.',
+    'aliases' => array('lssp'),
+    'arguments' => array(
+      'ldap_sid' => 'The configured LDAP server ID.'
+    ),
+    'options' => array(
+      'password' => 'The password to set for the server.'
+    ),
+    'examples' => array(
+      'drush lssp LDAP_SERVER_ID --password="PASSWORD"' => 'Sets the password for LDAP_SERVER_ID. Replace LDAP_SERVER_ID with the "Machine name for this configuration." of
+        the server found at /admin/config/people/ldap/servers, and replace PASSWORD with your password.',
+    ),
+  );
+  return $items;
+}
+
+/**
+ * Callback for the ldap-servers-set-password command.
+ *
+ * @param string $ldap_sid The server ID for which to set the password.
+ * @option string --password Used to provide the password via an option in the Drush command.
+ *
+ * @return
+ *   Error or success message.
+ */
+function drush_ldap_servers_set_password($ldap_sid = NULL) {
+  // Check for the argument.
+  if (!isset($ldap_sid)) {
+    return drush_set_error(t('The server ID was not included as an argument. Use the "Machine name for this server configuration." found on the edit screen for that server.'));
+  }
+  // Instantiate the server configuration with the provided sid.
+  ldap_servers_module_load_include('php', 'ldap_servers', 'LdapServerAdmin.class');
+  $ldap_server = new LdapServerAdmin($ldap_sid);
+  if (isset($ldap_server)) {
+    // Retrieves the password from the --password option set in the drush command.
+    $ldap_server->bindpw = drush_get_option('password');
+    if (!isset($ldap_server->bindpw)) {
+      return drupal_set_message(dt('No password was provided for @ldap_sid. A password has not been set.', array('@ldap_sid' => $ldap_sid)));
+    }
+    // Save the server configuration with the password.
+    $ldap_server->save('edit');
+    // Notify of success.
+    return drupal_set_message(dt('Password for @ldap_sid has been set.', array('@ldap_sid' => $ldap_sid)));
+  }
+  // Provided server ID does not match any of the existing server IDs.
+  return drush_set_error(dt('@ldap_sid does not match the server ID of any configured servers.  Use the "Machine name for this server configuration." found on the edit screen for that server.',
+    array('@ldap_sid' => $ldap_sid)));
+}
diff --git a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.encryption.inc b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.encryption.inc
index 3e65c985..f3c34f62 100644
--- a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.encryption.inc
+++ b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.encryption.inc
@@ -173,14 +173,17 @@ function _ldap_servers_decrypt($cipher_txt, $enc_type = NULL) {
         $key = substr($key, 0, $key_length);
         // Determine the algorithm IV.
         $ivsize = mcrypt_enc_get_iv_size($td);
-        // Split apart IV and text.
-        $iv = substr($cipher_txt, 0, $ivsize);
-        $cipher_txt = substr($cipher_txt, $ivsize);
-        // If the IV exists, decrypt the text.
-        if ($iv) {
-          mcrypt_generic_init($td, $key, $iv);
-          $clear_txt = mdecrypt_generic($td, $cipher_txt);
-          mcrypt_generic_deinit($td);
+        // Process if the decoded cipher text is sufficient.
+        if (strlen($cipher_txt) > $ivsize) {
+          // Split apart IV and text.
+          $iv = substr($cipher_txt, 0, $ivsize);
+          $cipher_txt = substr($cipher_txt, $ivsize);
+          // If the IV exists, decrypt the text.
+          if ($iv) {
+            mcrypt_generic_init($td, $key, $iv);
+            $clear_txt = mdecrypt_generic($td, $cipher_txt);
+            mcrypt_generic_deinit($td);
+          }
         }
         // Close the module.
         mcrypt_module_close($td);
diff --git a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.functions.inc b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.functions.inc
index 928d3e63..625fa738 100644
--- a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.functions.inc
+++ b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.functions.inc
@@ -47,6 +47,28 @@ function ldap_password_modify($userdn, $new_password, $ldap_server) {
   return $status;
 }
 
+/**
+ * Converts a password to the format that Active Directory supports (for the 
+ * purpose of changing or setting).  Note that AD needs the field to be called
+ * unicodePwd (as opposed to userPassword)
+ * 
+ * @param string $password
+ *    The password that is being formatted for Active Directory unicodePwd field
+ * @return string
+ *    $password surrounded with quotes and in UTF-16LE encoding
+ */
+function ldap_servers_convert_password_for_active_directory_unicodePwd($password) {
+  // This function can be called with $attributes['unicodePwd'] as an array.
+  if (!is_array($password)) {
+    return mb_convert_encoding("\"{$password}\"", "UTF-16LE");
+  }
+  else {
+    // Presumably there is no use case for there being more than one password in
+    // the $attributes array, hence it will be at index 0 and we return in kind.
+    return array(mb_convert_encoding("\"{$password[0]}\"", "UTF-16LE"));
+  }
+}
+
 /**
  *
  *  this attempts to find bad dns, but should only be used as warnings
@@ -226,6 +248,9 @@ function ldap_server_massage_text($value, $value_type, $context) {
         if ($is_scalar) {
             $values = array($values);
         }
+        if ($values === NULL) {
+          return NULL;
+        }
 
        foreach ($values as $key => $val) {
             // Escaping of filter meta characters
diff --git a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.info b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.info
index 419d6047..4b3734ec 100644
--- a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.info
+++ b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.info
@@ -17,9 +17,9 @@ files[] = ldap_servers.theme.inc
 files[] = tests/ldap_servers.test
 configure = admin/config/people/ldap/servers
 
-; Information added by Drupal.org packaging script on 2017-02-15
-version = "7.x-2.0-beta12"
+; Information added by Drupal.org packaging script on 2017-03-18
+version = "7.x-2.0"
 core = "7.x"
 project = "ldap"
-datestamp = "1487199794"
+datestamp = "1489858388"
 
diff --git a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.install b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.install
index 24f6cb93..2bffd414 100644
--- a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.install
+++ b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.install
@@ -84,7 +84,14 @@ function ldap_servers_requirements($phase) {
         try {
           $connect_result = $server->connect();
           if ($connect_result == LDAP_SUCCESS) {
-            $bind_result = $server->bind();
+            if ($server->bind_method == LDAP_SERVERS_BIND_METHOD_USER) {
+              // Check bind anonymously if set to bind via user credentials.
+              // The user has already logged in and so their is no dn or password
+              // to check since LDAP doesn't store passwords.
+              $bind_result = $server->bind(NULL, NULL, TRUE);
+            } else {
+              $bind_result = $server->bind();
+            }
             if ($bind_result == LDAP_SUCCESS) {
               $requirements[$server_req_key]['value'] = $t('Connection: Success, Bind: Success', $server_tokens);
               $requirements[$server_req_key]['severity'] = REQUIREMENT_OK;
diff --git a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.module b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.module
index 903620a0..d34fa513 100644
--- a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.module
+++ b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.module
@@ -320,12 +320,15 @@ function ldap_servers_theme() {
       if (!isset($attributes[$ldap_server->mail_attr])) {
         $attributes[$ldap_server->mail_attr] = ldap_servers_set_attribute_map();
       }
-      if (!isset($attributes[$ldap_server->picture_attr])) {
+      if ($ldap_server->picture_attr && !isset($attributes[$ldap_server->picture_attr])) {
         $attributes[$ldap_server->picture_attr] = ldap_servers_set_attribute_map();
       }
       if ($ldap_server->unique_persistent_attr && !isset($attributes[$ldap_server->unique_persistent_attr])) {
         $attributes[$ldap_server->unique_persistent_attr] = ldap_servers_set_attribute_map();
       }
+      if ($ldap_server->groupUserMembershipsAttr && !isset($attributes[$ldap_server->groupUserMembershipsAttr])) {
+        $attributes[$ldap_server->groupUserMembershipsAttr] = ldap_servers_set_attribute_map();
+      }
       if ($ldap_server->user_dn_expression) {
         ldap_servers_token_extract_attributes($attributes, $ldap_server->user_dn_expression, TRUE);
       }
diff --git a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.test_form.inc b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.test_form.inc
index e0f9640a..a8756333 100644
--- a/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.test_form.inc
+++ b/drupal7/sites/all/modules/ldap/ldap_servers/ldap_servers.test_form.inc
@@ -277,7 +277,9 @@ function ldap_servers_test_form_submit($form, &$form_state) {
     $group_dn = $values['grp_test_grp_dn'];
 
     $result = @ldap_read($ldap_server->connection, $group_dn, 'objectClass=*');
-    $group_entry = ldap_get_entries($ldap_server->connection, $result);
+    if (is_array($result)) {
+      $group_entry = ldap_get_entries($ldap_server->connection, $result);
+    }
     $user = isset($values['testing_drupal_username']) ? $values['testing_drupal_username'] : NULL;
 
     foreach (array(FALSE, TRUE) as $nested) { //FALSE
@@ -347,7 +349,7 @@ function ldap_servers_test_form_submit($form, &$form_state) {
     $form_state['ldap_server_test_data']['ldap_user'] = $ldap_user;
   }
 
-  if ( isset($group_entry) ) {
+  if (isset($group_entry) ) {
     $form_state['ldap_server_test_data']['group_entry'] = $group_entry;
   }
   
diff --git a/drupal7/sites/all/modules/ldap/ldap_sso/ldap_sso.info b/drupal7/sites/all/modules/ldap/ldap_sso/ldap_sso.info
index 4bd2c493..bd9efbd3 100644
--- a/drupal7/sites/all/modules/ldap/ldap_sso/ldap_sso.info
+++ b/drupal7/sites/all/modules/ldap/ldap_sso/ldap_sso.info
@@ -6,9 +6,9 @@ dependencies[] = ldap_authentication
 core = 7.x
 configure = admin/config/people/ldap/authentication
 
-; Information added by Drupal.org packaging script on 2017-02-15
-version = "7.x-2.0-beta12"
+; Information added by Drupal.org packaging script on 2017-03-18
+version = "7.x-2.0"
 core = "7.x"
 project = "ldap"
-datestamp = "1487199794"
+datestamp = "1489858388"
 
diff --git a/drupal7/sites/all/modules/ldap/ldap_test/ldap_test.info b/drupal7/sites/all/modules/ldap/ldap_test/ldap_test.info
index feedf4ad..2e9d8d3b 100644
--- a/drupal7/sites/all/modules/ldap/ldap_test/ldap_test.info
+++ b/drupal7/sites/all/modules/ldap/ldap_test/ldap_test.info
@@ -18,9 +18,9 @@ files[] = LdapServerTest.class.php
 files[] = LdapTestFunctions.class.php
 files[] = LdapUserTestCase.class.php
 
-; Information added by Drupal.org packaging script on 2017-02-15
-version = "7.x-2.0-beta12"
+; Information added by Drupal.org packaging script on 2017-03-18
+version = "7.x-2.0"
 core = "7.x"
 project = "ldap"
-datestamp = "1487199794"
+datestamp = "1489858388"
 
diff --git a/drupal7/sites/all/modules/ldap/ldap_user/LdapUserConf.class.php b/drupal7/sites/all/modules/ldap/ldap_user/LdapUserConf.class.php
index 2bfbef8d..0dac10d9 100644
--- a/drupal7/sites/all/modules/ldap/ldap_user/LdapUserConf.class.php
+++ b/drupal7/sites/all/modules/ldap/ldap_user/LdapUserConf.class.php
@@ -509,7 +509,7 @@ class LdapUserConf {
     if (is_scalar($account)) {
       $username = $account;
       $account = new stdClass();
-      $acount->name = $username;
+      $account->name = $username;
     }
 
     list($account, $user_entity) = ldap_user_load_user_acct_and_entity($account->name);
@@ -867,9 +867,8 @@ class LdapUserConf {
     // determine server that is associated with user
 
     $boolean_result = FALSE;
-    $language = ($account->language) ? $account->language : LANGUAGE_NONE;
-    if (isset($account->ldap_user_prov_entries[$language][0])) {
-      foreach ($account->ldap_user_prov_entries[$language] as $i => $field_instance) {
+    if (isset($account->ldap_user_prov_entries[LANGUAGE_NONE][0])) {
+      foreach ($account->ldap_user_prov_entries[LANGUAGE_NONE] as $i => $field_instance) {
         $parts = explode('|', $field_instance['value']);
         if (count($parts) == 2) {
 
diff --git a/drupal7/sites/all/modules/ldap/ldap_user/LdapUserConfAdmin.class.php b/drupal7/sites/all/modules/ldap/ldap_user/LdapUserConfAdmin.class.php
index 6b7c8f0e..bd984fec 100644
--- a/drupal7/sites/all/modules/ldap/ldap_user/LdapUserConfAdmin.class.php
+++ b/drupal7/sites/all/modules/ldap/ldap_user/LdapUserConfAdmin.class.php
@@ -998,23 +998,7 @@ EOT;
 
     );
 
-    $values['orphanedDrupalAcctBehaviorDescription'] = '<ul>' .
-       '<li style="color: red">' . t('This is a new feature as of 11/7/2012!
-        It is highly recommended to use the "Perform no action,
-        but email list of orphaned accounts" for some time before using the
-        "Disable the account" options.') . '</li>' .
-
-      '<li>' . t('These actions will only occur if the query to server is successful
-      and does not return a user entry.  If the ldap server is down or otherwise
-      cannot be connected to, no actions
-      will be performed.') . '</li>' .
-
-      '<li>' .
-      t('When initially using this option, its best to simply check email and
-        delete the accounts by hand.  When you are happy with the
-      behavior, switch to one of the automated options.') . '</li>' .
-
-      '</ul>';
+    $values['orphanedDrupalAcctBehaviorDescription'] = t('It is highly recommended to use the "Perform no action, but email list of orphaned accounts" for some time before considering switching to "Disable the account" options.');
 
 
     $values['manualAccountConflictOptions'] =  array(
diff --git a/drupal7/sites/all/modules/ldap/ldap_user/ldap_user.info b/drupal7/sites/all/modules/ldap/ldap_user/ldap_user.info
index 8c42525c..a69cecb4 100644
--- a/drupal7/sites/all/modules/ldap/ldap_user/ldap_user.info
+++ b/drupal7/sites/all/modules/ldap/ldap_user/ldap_user.info
@@ -23,9 +23,9 @@ files[] = tests/ldap_user.test
 stylesheets[all][] = ldap_user.css
 configure = admin/config/people/ldap/user
 
-; Information added by Drupal.org packaging script on 2017-02-15
-version = "7.x-2.0-beta12"
+; Information added by Drupal.org packaging script on 2017-03-18
+version = "7.x-2.0"
 core = "7.x"
 project = "ldap"
-datestamp = "1487199794"
+datestamp = "1489858388"
 
diff --git a/drupal7/sites/all/modules/ldap/ldap_user/ldap_user.module b/drupal7/sites/all/modules/ldap/ldap_user/ldap_user.module
index 3dbf733c..8cca143a 100644
--- a/drupal7/sites/all/modules/ldap/ldap_user/ldap_user.module
+++ b/drupal7/sites/all/modules/ldap/ldap_user/ldap_user.module
@@ -228,8 +228,12 @@ function ldap_user_ldap_attributes_needed_alter(&$attributes, $params) {
       case 'all':
         $attributes[$ldap_server->user_attr] = ldap_servers_set_attribute_map(@$attributes[$ldap_server->user_attr]); // array($ldap_server->user_attr, 0, NULL);
         $attributes[$ldap_server->mail_attr] = ldap_servers_set_attribute_map(@$attributes[$ldap_server->mail_attr]);
-        $attributes[$ldap_server->picture_attr] = ldap_servers_set_attribute_map(@$attributes[$ldap_server->picture_attr]);
-        $attributes[$ldap_server->unique_persistent_attr] = ldap_servers_set_attribute_map(@$attributes[$ldap_server->unique_persistent_attr]);
+        if ($ldap_server->picture_attr) {
+          $attributes[$ldap_server->picture_attr] = ldap_servers_set_attribute_map(@$attributes[$ldap_server->picture_attr]);
+        }
+        if ($ldap_server->unique_persistent_attr) {
+          $attributes[$ldap_server->unique_persistent_attr] = ldap_servers_set_attribute_map(@$attributes[$ldap_server->unique_persistent_attr]);
+        }
         if ($ldap_server->mail_template) {
           ldap_servers_token_extract_attributes($attributes,  $ldap_server->mail_template);
         }
@@ -491,6 +495,15 @@ function ldap_user_form_password_policy_password_tab_alter(&$form, &$form_state)
   array_unshift($form['#validate'], 'ldap_user_grab_password_validate');
 }
 
+/**
+* Implements hook_form_FORM_ID_alter(). for user-pass-reset form. Useful for
+* sites where this is the form ID for a user to intially set their password
+* (user clicks an emailed registration link, is prompted to set their password).
+*/
+function ldap_user_form_user_pass_reset_alter(&$form, &$form_state) {
+  array_unshift($form['#validate'], 'ldap_user_grab_password_validate');
+}
+
 /**
  * store password from logon forms in ldap_user_ldap_provision_pwd static variable
  * for use in provisioning to ldap
@@ -763,10 +776,8 @@ function ldap_user_provision_to_drupal($ldap_user, $user_edit = array()) {
  *   and protect unencrypted user password from other modules
  *
  *   @param enum string $action 'get' | 'set'
- *   @param string | FALE $value as user entered password
+ *   @param string | FALSE $value as user entered password
  */
-
-
 function ldap_user_ldap_provision_pwd($action, $value = NULL, $reset = FALSE) {
 
   //$calling_function = FALSE;
